Unit BK07R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, BS03R1_p, BK06R1_p;

procedure BK07R(var DATA1 :Array of Real; var N1 :Integer;
                var DATA2 :Array of Real; var N2 :Integer;
                var PROB :Real);

implementation

procedure BK07R(var DATA1 :Array of Real; var N1 :Integer;
                var DATA2 :Array of Real; var N2 :Integer;
                var PROB :Real);
var
J1,J2 :Integer;
EN1,EN2,FO1,FO2,D,FN1,DT,FN2 :Real;
label
_1,_10,_20,_30;
begin
BS03R1(N1,DATA1);
BS03R1(N2,DATA2);
EN1 := N1;
EN2 := N2;
J1 := 1;
J2 := 1;
FO1 := 0.0;
FO2 := 0.0;
D := 0.0;
_1:
if ( not (J1 <= N1 ) and ( J2 <= N2) ) 
 then goto _30;
if ( not (DATA1[J1-1] < DATA2[J2-1]) ) 
 then goto _10;
FN1 := J1/EN1;
DT := EMax1(Abs(FN1-FO2),Abs(FO1-FO2));
if ( DT > D )
 then D := DT;
FO1 := FN1;
J1 := J1+1;
goto _20;
_10:
FN2 := J2/EN2;
DT := EMax1(Abs(FN2-FO1),Abs(FO2-FO1));
if ( DT > D )
 then D := DT;
FO2 := FN2;
J2 := J2+1;
_20:
goto _1;
_30:
PROB := BK06R1(Sqrt(EN1*EN2/(EN1+EN2))*D);
end;

end.
